#include "com.h"

int connectto(struct sockaddr_in *adresa){
/* pripoji se na adresu a vrati cislo socketu */
	int sd;
	int option = 1;

	if((sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
	{
		fprintf(stderr, "socket: %s\n", strerror(errno));
		return -1;
	}

	if (setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, &option, sizeof(option)) == -1)
    {
        fprintf(stderr, "setsockopt: %s\n", strerror(errno));
        return -1;
    }
  
    if (connect(sd, (struct sockaddr *) adresa, sizeof(struct sockaddr_in)) == -1)
    {
        fprintf(stderr, "connect: %s\n", strerror(errno));
        return -1;
    }

    return sd;
}

int socketset(struct sockaddr_in *adresa, const parametry_spojeni *spoj_info){
	/* Nastaveni parametru spojeni */
	memset(adresa, 0, sizeof(struct sockaddr_in));
	adresa->sin_family = AF_INET;
	adresa->sin_port = htons(spoj_info->port);
	adresa->sin_addr.s_addr = (unsigned long int) inet_addr(spoj_info->ip);
	return 0;	
}

char *print_cmd(commands prikaz){
	switch(prikaz){
		case PRINT:		return "PRINT";	break;
		case CANCEL: 	return "CANCEL"; break;
		case STOP:  	return "STOP"; break;
		case START: 	return "START"; break;
		case PRIORITY: 	return "PRIORITY"; break;
		case DISPLAY: 	return "DISPLAY"; break;
		default: break;
	}
	return "Zadny ukol!";
}

void print_options(parametry_spojeni *spoj_info){
	printf("Host: %s\n", spoj_info->ip);
	printf("Port: %u\n", spoj_info->port);
	printf("File: %s\n", spoj_info->filename);
	printf("User: %s (ID = %d)\n", spoj_info->username, spoj_info->userid);
	printf("Job: %u\n", spoj_info->job);
	printf("Cmd: %s\n", print_cmd(spoj_info->todo));
	
	return;
}


char *hostnamefromaddr(char *ip_adresa){
	struct hostent *remote_info;
	struct in_addr adresa;

	if(inet_aton(ip_adresa, &adresa) == -1){
		fprintf(stderr, "inet_aton: %s\n", strerror(errno));
		return NULL;
	}
		
	if((remote_info = gethostbyaddr(&adresa, sizeof(struct in_addr), AF_INET)) == NULL){
		herror(ip_adresa);
		return NULL;
	}

	return remote_info->h_name;
}

int openfile(char *filename, int flags){
	int fd;

	if((fd = open(filename, flags)) == -1){
		fprintf(stderr, "open: %s\n", strerror(errno));
		return(-1);
	}
	return fd;
}


